#!/usr/bin/python

from earl   import *
from sys    import *

t = EventTrace(argv[1])

for cnode in t.calltree():
    cp = t.callpath(cnode)
    for pos in cp:
        e = t.event(pos)
        region = t.get_reg(e['reg_id'])['name']
        if e['csite_id'] != -1:
            line = str(t.get_csite(e['csite_id'])['line'])
            print t.get_reg(e['reg_id'])['name'], ":", line, "/",
        else:
            print t.get_reg(e['reg_id'])['name'], "/",
            
    print "[", t.ctvisits(cnode), "]"
        
del t







