/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "Module.h"
#include "Function.h"

ostream& operator<<(ostream& out, const Module& mod)
{
  out << "MODULE" << " "
      << mod.id << " " 
      << mod.name << " "
      << mod.funcv.size();
  
  for (int i = 0; i < mod.funcv.size(); i++)
    out << " " << mod.funcv[i]->id;

  out << endl;

  return out;
}
