/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                ** 
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         ** 
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef DLG_MOD_H
#define DLG_MOD_H

#include <stdio.h>

struct dlg_mod;

struct dlg_mod*  dlg_mod_create(char* modspec);
void             dlg_mod_delete(struct dlg_mod* mod);

long             dlg_mod_id(struct dlg_mod* mod);
const char*      dlg_mod_name(struct dlg_mod* mod);
long             dlg_mod_num_funcs(struct dlg_mod* mod);
long             dlg_mod_func_id(struct dlg_mod* mod, long i);

void             dlg_mod_set_tag(struct dlg_mod* mod, long tag);
long             dlg_mod_get_tag(struct dlg_mod* mod);

void             dlg_mod_fprintf(FILE* stream, struct dlg_mod* mod);

#endif
