/****************************************************************************
** KOJAK                                                                  **
** http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
** Copyright (c) 1998-2004                                                **
** Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                        **
** See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#define MPI_Init_U		MPI_INIT
#define MPI_Finalize_U		MPI_FINALIZE
#define MPI_Comm_dup_U		MPI_COMM_DUP
#define MPI_Comm_create_U	MPI_COMM_CREATE
#define MPI_Comm_split_U	MPI_COMM_SPLIT
#define MPI_Cart_create_U	MPI_CART_CREATE
#define MPI_Cart_sub_U		MPI_CART_SUB
#define MPI_Graph_create_U	MPI_GRAPH_CREATE
#define MPI_Intercomm_create_U	MPI_INTERCOMM_CREATE
#define MPI_Intercomm_merge_U	MPI_INTERCOMM_MERGE
#define MPI_Comm_free_U		MPI_COMM_FREE
#define MPI_Send_U		MPI_SEND
#define MPI_Bsend_U		MPI_BSEND
#define MPI_Rsend_U		MPI_RSEND
#define MPI_Ssend_U		MPI_SSEND
#define MPI_Recv_U		MPI_RECV
#define MPI_Sendrecv_U		MPI_SENDRECV
#define MPI_Sendrecv_replace_U	MPI_SENDRECV_REPLACE
#define MPI_Isend_U		MPI_ISEND
#define MPI_Irecv_U		MPI_IRECV
#define MPI_Ibsend_U		MPI_IBSEND
#define MPI_Issend_U		MPI_ISSEND
#define MPI_Irsend_U		MPI_IRSEND
#define MPI_Wait_U		MPI_WAIT
#define MPI_Wait_all_U		MPI_WAIT_ALL
#define MPI_Wait_any_U		MPI_WAIT_ANY
#define MPI_Wait_some_U		MPI_WAIT_SOME
#define MPI_Test_U		MPI_TEST
#define MPI_Testany_U		MPI_TESTANY
#define MPI_Testall_U		MPI_TESTALL
#define MPI_Testsome_U		MPI_TESTSOME
#define MPI_Send_init_U		MPI_SEND_INIT
#define MPI_Recv_init_U		MPI_RECV_INIT
#define MPI_Bsend_init_U	MPI_BSEND_INIT
#define MPI_Ssend_init_U	MPI_SSEND_INIT
#define MPI_Rsend_init_U	MPI_RSEND_INIT
#define MPI_Start_U		MPI_START
#define MPI_Startall_U		MPI_STARTALL
#define MPI_Request_free_U	MPI_REQUEST_FREE
#define MPI_Cancel_U		MPI_CANCEL
#define MPI_Allreduce_U		MPI_ALLREDUCE
#define MPI_Barrier_U		MPI_BARRIER
#define MPI_Bcast_U		MPI_BCAST
#define MPI_Gather_U		MPI_GATHER
#define MPI_Reduce_U		MPI_REDUCE
#define MPI_Gatherv_U		MPI_GATHERV
#define MPI_Allgather_U		MPI_ALLGATHER
#define MPI_Allgatherv_U	MPI_ALLGATHERV
#define MPI_Alltoall_U		MPI_ALLTOALL
#define MPI_Alltoallv_U		MPI_ALLTOALLV
#define MPI_Scan_U		MPI_SCAN
#define MPI_Scatter_U		MPI_SCATTER
#define MPI_Scatterv_U		MPI_SCATTERV
#define MPI_Reduce_scatter_U	MPI_REDUCE_SCATTER

#define MPI_Init_L		mpi_init
#define MPI_Finalize_L		mpi_finalize
#define MPI_Comm_dup_L		mpi_comm_dup
#define MPI_Comm_create_L	mpi_comm_create
#define MPI_Comm_split_L	mpi_comm_split
#define MPI_Cart_create_L	mpi_cart_create
#define MPI_Cart_sub_L		mpi_cart_sub
#define MPI_Graph_create_L	mpi_graph_create
#define MPI_Intercomm_create_L	mpi_intercomm_create
#define MPI_Intercomm_merge_L	mpi_intercomm_merge
#define MPI_Comm_free_L		mpi_comm_free
#define MPI_Send_L		mpi_send
#define MPI_Bsend_L		mpi_bsend
#define MPI_Rsend_L		mpi_rsend
#define MPI_Ssend_L		mpi_ssend
#define MPI_Recv_L		mpi_recv
#define MPI_Sendrecv_L		mpi_sendrecv
#define MPI_Sendrecv_replace_L	mpi_sendrecv_replace
#define MPI_Isend_L		mpi_isend
#define MPI_Irecv_L		mpi_irecv
#define MPI_Ibsend_L		mpi_ibsend
#define MPI_Issend_L		mpi_issend
#define MPI_Irsend_L		mpi_irsend
#define MPI_Wait_L		mpi_wait
#define MPI_Waitall_L		mpi_waitall
#define MPI_Waitany_L		mpi_waitany
#define MPI_Waitsome_L		mpi_waitsome
#define MPI_Test_L		mpi_test
#define MPI_Testany_L		mpi_testany
#define MPI_Testall_L		mpi_testall
#define MPI_Testsome_L		mpi_testsome
#define MPI_Send_init_L		mpi_send_init
#define MPI_Recv_init_L		mpi_recv_init
#define MPI_Bsend_init_L	mpi_bsend_init
#define MPI_Ssend_init_L	mpi_ssend_init
#define MPI_Rsend_init_L	mpi_rsend_init
#define MPI_Start_L		mpi_start
#define MPI_Startall_L		mpi_startall
#define MPI_Request_free_L	mpi_request_free
#define MPI_Cancel_L		mpi_cancel
#define MPI_Allreduce_L		mpi_allreduce
#define MPI_Barrier_L		mpi_barrier
#define MPI_Bcast_L		mpi_bcast
#define MPI_Gather_L		mpi_gather
#define MPI_Reduce_L		mpi_reduce
#define MPI_Gatherv_L		mpi_gatherv
#define MPI_Allgather_L		mpi_allgather
#define MPI_Allgatherv_L	mpi_allgatherv
#define MPI_Alltoall_L		mpi_alltoall
#define MPI_Alltoallv_L		mpi_alltoallv
#define MPI_Scan_L		mpi_scan
#define MPI_Scatter_L		mpi_scatter
#define MPI_Scatterv_L		mpi_scatterv
#define MPI_Reduce_scatter_L	mpi_reduce_scatter

#include "pomp_fwrapper_def.h"
#include "elg_fmpi_defs.h"
#include "elg_error.h"
#include <stdlib.h>
#include <mpi.h>

#if defined(__sun) || defined(_SX)
#  define NEED_F2C_CONV
#endif

#ifndef NEED_F2C_CONV

/* If MPI_Comm_f2c is defined as a simple macro (which typically does nothing)
 * as it would require a "real" function if it is really needed
 * => we can save the f2c and c2s conversions */

void FSUB(MPI_Init)(int* ierr) {
  *ierr = MPI_Init(0, (char***)0);
}

void FSUB(MPI_Finalize)(int* ierr) {
  *ierr = MPI_Finalize();
}

void FSUB(MPI_Comm_dup)(MPI_Comm* comm, MPI_Comm* newcomm, int* ierr) {
  *ierr = MPI_Comm_dup(*comm, newcomm);
}

void FSUB(MPI_Comm_create)(MPI_Comm* comm, MPI_Group* group, MPI_Comm* newcomm,
		int* ierr) {
  *ierr = MPI_Comm_create(*comm, *group, newcomm);
}

void FSUB(MPI_Comm_split)(MPI_Comm* comm, 
		int* color, int* key, MPI_Comm* newcomm, int* ierr) {
  *ierr = MPI_Comm_split(*comm, *color, *key, newcomm);
}

void FSUB(MPI_Cart_create)(MPI_Comm* comm_old, int* ndims, int* dims,
		int* periods, int* reorder, MPI_Comm* comm_cart, int* ierr) {
  *ierr = MPI_Cart_create(*comm_old, *ndims, dims, periods,
		*reorder, comm_cart);
}

void FSUB(MPI_Cart_sub)(MPI_Comm* comm, int* remain_dims, MPI_Comm* comm_new,
		int* ierr) {
  *ierr = MPI_Cart_sub(*comm, remain_dims, comm_new);
}

void FSUB(MPI_Graph_create)(MPI_Comm* comm_old, int* nnodes, int* index,
		int* edges, int* reorder, MPI_Comm* comm_graph, int* ierr) {
  *ierr = MPI_Graph_create(*comm_old, *nnodes, index, edges,
		*reorder, comm_graph);
}

void FSUB(MPI_Intercomm_create)(MPI_Comm* local_comm, int* local_leader,
		MPI_Comm* peer_comm, int* remote_leader, int* tag,
		MPI_Comm* comm_out, int* ierr) {
  *ierr = MPI_Intercomm_create(*local_comm, *local_leader, *peer_comm,
		*remote_leader, *tag, comm_out);
}

void FSUB(MPI_Intercomm_merge)(MPI_Comm* comm, int* high, MPI_Comm* comm_out,
		int* ierr) {
  *ierr = MPI_Intercomm_merge(*comm, *high, comm_out);
}

void FSUB(MPI_Comm_free)(MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Comm_free(comm);
}

void FSUB(MPI_Send)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Send(buf, *count, *datatype, *dest, *tag, *comm);
}

void FSUB(MPI_Bsend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Bsend(buf, *count, *datatype, *dest, *tag, *comm);
}

void FSUB(MPI_Rsend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Rsend(buf, *count, *datatype, *dest, *tag, *comm);
}

void FSUB(MPI_Ssend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Ssend(buf, *count, *datatype, *dest, *tag, *comm);
}

void FSUB(MPI_Recv)(void* buf, int* count, MPI_Datatype* datatype, int* source,
		int* tag, MPI_Comm* comm, MPI_Status* status, int* ierr) {
  *ierr = MPI_Recv(buf, *count, *datatype, *source, *tag, *comm, status);
}

void FSUB(MPI_Sendrecv)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype, 
		int* dest, int* sendtag, void* recvbuf, 
		int* recvcount, MPI_Datatype* recvtype, int* source, 
		int* recvtag, MPI_Comm* comm, MPI_Status* status, int* ierr) {
  *ierr = MPI_Sendrecv(sendbuf, *sendcount, *sendtype, *dest, *sendtag,
		recvbuf, *recvcount, *recvtype, *source, *recvtag,
		*comm, status);
}

void FSUB(MPI_Sendrecv_replace)(void* buf, int* count, MPI_Datatype* datatype,
		int* dest, int* sendtag, int* source, int* recvtag,
		MPI_Comm* comm, MPI_Status * status, int* ierr) {
  *ierr = MPI_Sendrecv_replace(buf, *count, *datatype, *dest, *sendtag,
		*source, *recvtag, *comm, status);
}

void FSUB(MPI_Isend)(void* buf, int* count, MPI_Datatype* datatype, 
		int* dest, int* tag, MPI_Comm* comm, MPI_Request* request,
		int* ierr) {
  *ierr = MPI_Isend(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Irecv)(void* buf, int* count, MPI_Datatype* datatype, int* source,
		int* tag, MPI_Comm* comm, MPI_Request* request, int* ierr) {
  *ierr = MPI_Irecv(buf, *count, *datatype, *source, *tag, *comm, request);
}

void FSUB(MPI_Ibsend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, MPI_Request * request, int* ierr) {
  *ierr = MPI_Ibsend(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Issend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, MPI_Request* request, int* ierr) {
  *ierr = MPI_Issend(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Irsend)(void* buf, int* count, MPI_Datatype* datatype, int* dest,
		int* tag, MPI_Comm* comm, MPI_Request * request, int* ierr) {
  *ierr = MPI_Irsend(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Wait)(MPI_Request* request, MPI_Status* status, int* ierr) {
  *ierr = MPI_Wait(request, status);
}

void FSUB(MPI_Waitall)(int* count, MPI_Request* requests, MPI_Status* statuses,
		int* ierr) {
  *ierr = MPI_Waitall(*count, requests, statuses);
}

void FSUB(MPI_Waitany)(int* count, MPI_Request* array, int* index, 
		MPI_Status* status, int* ierr) {
  *ierr = MPI_Waitany(*count, array, index, status);
  /* See the description of waitany in the standard;
     the Fortran index ranges are from 1, not zero */
  if (*index >= 0) (*index)++;
}

void FSUB(MPI_Waitsome)(int* incount, MPI_Request * array_of_requests,
		int* outcount, int* array_of_indices,
		MPI_Status * array_of_statuses, int* ierr) {
  int i;

  *ierr = MPI_Waitsome(*incount, array_of_requests, outcount,
		array_of_indices, array_of_statuses); 
  for (i=0; i<*outcount; i++) {
    if (array_of_indices[i] >= 0) array_of_indices[i]++;
  }
}

void FSUB(MPI_Test)(MPI_Request* request, int* flag, MPI_Status* status,
		int* ierr) {
  *ierr = MPI_Test(request, flag, status);
}

void FSUB(MPI_Testany)(int* count, MPI_Request * array_of_requests,
		int* index, int* flag, MPI_Status * status, int* ierr) {
  *ierr  = MPI_Testany(*count, array_of_requests, index, flag, status);
  if (*flag && *index >= 0) (*index)++;
}

void FSUB(MPI_Testall)(int* count, MPI_Request * array_of_requests,
		int* flag, MPI_Status * array_of_statuses, int* ierr)
{
  *ierr = MPI_Testall(*count, array_of_requests, flag, array_of_statuses);
}

void FSUB(MPI_Testsome)(int* incount, MPI_Request * array_of_requests,
		int* outcount, int* array_of_indices,
		MPI_Status * array_of_statuses, int* ierr) {
  int i;

  *ierr = MPI_Testsome(*incount, array_of_requests, outcount, array_of_indices,
		array_of_statuses);
  for (i=0; i<*outcount; i++) {
    if (array_of_indices[i] >= 0) array_of_indices[i]++;
  }
}

void FSUB(MPI_Send_init)(void* buf, int* count, MPI_Datatype* datatype, 
		int* dest, int* tag, MPI_Comm* comm, MPI_Request* request,
		int* ierr) {
  *ierr = MPI_Send_init(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Recv_init)(void* buf, int* count, MPI_Datatype* datatype, 
		int* source, int* tag, MPI_Comm* comm, MPI_Request* request,
		int* ierr) {
  *ierr = MPI_Recv_init(buf, *count, *datatype, *source, *tag, *comm, request);
}

void FSUB(MPI_Bsend_init)(void* buf, int* count, MPI_Datatype* datatype,
		int* dest, int* tag, MPI_Comm* comm, MPI_Request * request,
		int* ierr) {
  *ierr = MPI_Bsend_init(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Ssend_init)(void* buf, int* count, MPI_Datatype* datatype,
		int* dest, int* tag, MPI_Comm* comm, MPI_Request * request,
		int* ierr) {
  *ierr = MPI_Ssend_init(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Rsend_init)(void* buf, int* count, MPI_Datatype* datatype,
		int* dest, int* tag, MPI_Comm* comm, MPI_Request * request,
		int* ierr) {
  *ierr = MPI_Rsend_init(buf, *count, *datatype, *dest, *tag, *comm, request);
}

void FSUB(MPI_Start)(MPI_Request* request, int* ierr) {
  *ierr = MPI_Start(request);
}

void FSUB(MPI_Startall)(int* count, MPI_Request* array_of_requests, int* ierr) {
  *ierr = MPI_Startall(*count, array_of_requests);
}

void FSUB(MPI_Request_free)(MPI_Request* request, int* ierr) {
  *ierr = MPI_Request_free(request);
}

void FSUB(MPI_Cancel)(MPI_Request * request, int* ierr) {
  *ierr = MPI_Cancel(request);
}

void FSUB(MPI_Allreduce)(void* sendbuf, void* recvbuf, int* count, 
		MPI_Datatype* datatype, MPI_Op* op, MPI_Comm* comm,
		int* ierr) {
  *ierr = MPI_Allreduce(sendbuf, recvbuf, *count, *datatype, *op, *comm);
}

void FSUB(MPI_Barrier)(MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Barrier(*comm);
}

void FSUB(MPI_Bcast)(void* buf, int* count, MPI_Datatype* datatype, int* root,
		MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Bcast(buf, *count, *datatype, *root, *comm);
}

void FSUB(MPI_Gather)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcount, MPI_Datatype* recvtype,
		int* root, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Gather(sendbuf, *sendcount, *sendtype, recvbuf, *recvcount,
		*recvtype, *root, *comm);
}

void FSUB(MPI_Reduce)(void* sendbuf, void* recvbuf, int* count, 
		MPI_Datatype* datatype, MPI_Op* op, int* root, 
		MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Reduce(sendbuf, recvbuf, *count, *datatype, *op, *root, *comm);
}

void FSUB(MPI_Gatherv)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcounts, int* displs,
		MPI_Datatype* recvtype, int* root, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Gatherv(sendbuf, *sendcount, *sendtype, recvbuf, recvcounts,
		displs, *recvtype, *root, *comm);
}

void FSUB(MPI_Allgather)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcount, MPI_Datatype* recvtype, 
		MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Allgather(sendbuf, *sendcount, *sendtype, recvbuf, *recvcount,
		*recvtype, *comm);
}

void FSUB(MPI_Allgatherv)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcounts, int* displs,
		MPI_Datatype* recvtype, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Allgatherv(sendbuf, *sendcount, *sendtype, recvbuf, recvcounts,
		displs, *recvtype, *comm);
}

void FSUB(MPI_Alltoall)(void* sendbuf, int* sendcount, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcnt, MPI_Datatype* recvtype,
		MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Alltoall(sendbuf, *sendcount, *sendtype, recvbuf, *recvcnt,
		*recvtype, *comm);
}

void FSUB(MPI_Alltoallv)(void* sendbuf, int* sendcnts, int* sdispls,
		MPI_Datatype* sendtype, void* recvbuf, int* recvcnts,
		int* rdispls, MPI_Datatype* recvtype, MPI_Comm* comm,
		int* ierr) {
  *ierr = MPI_Alltoallv(sendbuf, sendcnts, sdispls, *sendtype, recvbuf,
		recvcnts, rdispls, *recvtype, *comm);
}

void FSUB(MPI_Scan)(void* sendbuf, void* recvbuf, int* count,
		MPI_Datatype* datatype, MPI_Op* op, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Scan(sendbuf, recvbuf, *count, *datatype, *op, *comm);
}

void FSUB(MPI_Scatter)(void* sendbuf, int* sendcnt, MPI_Datatype* sendtype,
		void* recvbuf, int* recvcnt, MPI_Datatype* recvtype,
		int* root, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Scatter(sendbuf, *sendcnt, *sendtype, recvbuf, *recvcnt,
		*recvtype, *root, *comm);
}

void FSUB(MPI_Scatterv)(void* sendbuf, int* sendcnts, int* displs,
		MPI_Datatype* sendtype, void* recvbuf, int* recvcnt,
		MPI_Datatype* recvtype, int* root, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Scatterv(sendbuf, sendcnts, displs, *sendtype, recvbuf,
		*recvcnt, *recvtype, *root, *comm);
}

void FSUB(MPI_Reduce_scatter)(void* sendbuf, void* recvbuf, int* recvcnts,
		MPI_Datatype* datatype, MPI_Op* op, MPI_Comm* comm, int* ierr) {
  *ierr = MPI_Reduce_scatter(sendbuf, recvbuf, recvcnts, *datatype, *op, *comm);
}

#else /* !NEED_F2C_CONV */

static MPI_Request *alloc_request_array(int count) {
  static MPI_Request *local_req_arr = 0;
  static int local_req_arr_size = 0;

  if (local_req_arr_size == 0) {
    /* -- never used: initialize -- */
    local_req_arr = malloc(2 * count * sizeof(MPI_Request));
    local_req_arr_size = 2 * count;
  } else if (count > local_req_arr_size) {
    /* -- not enough room: expand -- */
    local_req_arr = realloc(local_req_arr, count * sizeof(MPI_Request));
    local_req_arr_size = count;
  }
  return local_req_arr;
}

static MPI_Status *alloc_status_array(int count) {
  static MPI_Status *local_stat_arr = 0;
  static int local_stat_arr_size = 0;

  if (local_stat_arr_size == 0) {
    /* -- never used: initialize -- */
    local_stat_arr = malloc(2 * count * sizeof(MPI_Status));
    local_stat_arr_size = 2 * count;
  } else if (count > local_stat_arr_size) {
    /* -- not enough room: expand -- */
    local_stat_arr = realloc(local_stat_arr, count * sizeof(MPI_Status));
    local_stat_arr_size = count;
  }
  return local_stat_arr;
}

void FSUB(MPI_Init)(int* ierr) {
  if (sizeof(MPI_Fint) != sizeof(int)) {
    elg_error_msg("Fortran and C integer size missmatch.");
  }
  *ierr = MPI_Init(0, (char***)0);
}

void FSUB(MPI_Finalize)(int* ierr) {
  *ierr = MPI_Finalize();
}

void FSUB(MPI_Comm_dup)(MPI_Fint *comm, MPI_Fint *comm_out, MPI_Fint *__ierr) {
  MPI_Comm l_comm_out;

  *__ierr = MPI_Comm_dup(MPI_Comm_f2c(*comm), &l_comm_out);
  if (*__ierr == MPI_SUCCESS) *comm_out = MPI_Comm_c2f(l_comm_out);
}

void FSUB(MPI_Comm_create)(MPI_Fint *comm, MPI_Fint *group, MPI_Fint *comm_out,
	MPI_Fint *__ierr) {
 MPI_Comm l_comm_out;

 *__ierr = MPI_Comm_create(MPI_Comm_f2c(*comm), MPI_Group_f2c(*group),
		&l_comm_out);
 if (*__ierr == MPI_SUCCESS) *comm_out = MPI_Comm_c2f(l_comm_out);
}

void FSUB(MPI_Comm_split)(MPI_Fint *comm, MPI_Fint *color, MPI_Fint *key,
	MPI_Fint *comm_out, MPI_Fint *__ierr) {
 MPI_Comm l_comm_out;

 *__ierr = MPI_Comm_split(MPI_Comm_f2c(*comm), *color, *key, &l_comm_out);
 if (*__ierr == MPI_SUCCESS) *comm_out = MPI_Comm_c2f(l_comm_out);
}

void FSUB(MPI_Cart_create)(MPI_Fint *comm_old, MPI_Fint *ndims, MPI_Fint *dims,
	MPI_Fint *periods, MPI_Fint *reorder, MPI_Fint *comm_cart,
	MPI_Fint *ierr) {
 MPI_Comm l_comm_cart;

 *ierr = MPI_Cart_create(MPI_Comm_f2c(*comm_old), *ndims, dims, periods,
		*reorder, &l_comm_cart);
 if (*ierr == MPI_SUCCESS) *comm_cart = MPI_Comm_c2f(l_comm_cart);
}

void FSUB(MPI_Cart_sub)(MPI_Fint *comm, MPI_Fint *remain_dims,
	MPI_Fint *comm_new, MPI_Fint *__ierr) {
 MPI_Comm lcomm_new;

 *__ierr = MPI_Cart_sub(MPI_Comm_f2c(*comm), remain_dims, &lcomm_new);
 if (*__ierr == MPI_SUCCESS) *comm_new = MPI_Comm_c2f(lcomm_new);
}

void FSUB(MPI_Graph_create)(MPI_Fint *comm_old, MPI_Fint *nnodes,
	MPI_Fint *index, MPI_Fint *edges, MPI_Fint *reorder,
	MPI_Fint *comm_graph, MPI_Fint *__ierr) {
  MPI_Comm lcomm_graph;

  *__ierr = MPI_Graph_create(MPI_Comm_f2c(*comm_old), *nnodes, index, edges,
		*reorder, &lcomm_graph);
  if (*__ierr == MPI_SUCCESS) *comm_graph = MPI_Comm_c2f(lcomm_graph);
}

void FSUB(MPI_Intercomm_create)(MPI_Fint *local_comm, MPI_Fint *local_leader,
	MPI_Fint *peer_comm, MPI_Fint *remote_leader, MPI_Fint *tag,
	MPI_Fint *comm_out, MPI_Fint *__ierr) {
  MPI_Comm l_comm_out;

  *__ierr = MPI_Intercomm_create(MPI_Comm_f2c(*local_comm), *local_leader, 
		MPI_Comm_f2c(*peer_comm), *remote_leader, *tag, &l_comm_out);
  if (*__ierr == MPI_SUCCESS) *comm_out = MPI_Comm_c2f(l_comm_out);
}

void FSUB(MPI_Intercomm_merge)(MPI_Fint *comm, MPI_Fint *high,
	MPI_Fint *comm_out, MPI_Fint *__ierr) {
  MPI_Comm l_comm_out;

  *__ierr = MPI_Intercomm_merge(MPI_Comm_f2c(*comm), *high, &l_comm_out);
  if (*__ierr == MPI_SUCCESS) *comm_out = MPI_Comm_c2f(l_comm_out); 
}

void FSUB(MPI_Comm_free)(MPI_Fint *comm, MPI_Fint *__ierr) {
  MPI_Comm l_comm = MPI_Comm_f2c(*comm);
  *__ierr = MPI_Comm_free(&l_comm);
  if (*__ierr == MPI_SUCCESS) *comm = MPI_Comm_c2f(l_comm);
}

void FSUB(MPI_Send)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *__ierr) {
  *__ierr = MPI_Send(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Bsend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *__ierr) {
  *__ierr = MPI_Bsend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm) );
}

void FSUB(MPI_Rsend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *__ierr) {
  *__ierr = MPI_Rsend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm) );
}

void FSUB(MPI_Ssend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *__ierr) {
  *__ierr = MPI_Ssend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm) );
}

void FSUB(MPI_Recv)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *source, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *status,
	MPI_Fint *__ierr) {
  MPI_Status c_status;

  *__ierr = MPI_Recv(buf, *count, MPI_Type_f2c(*datatype), *source, *tag,
		MPI_Comm_f2c(*comm), &c_status);
  if (*__ierr == MPI_SUCCESS) MPI_Status_c2f(&c_status, status);
}

void FSUB(MPI_Sendrecv)(void *sendbuf, MPI_Fint *sendcount, MPI_Fint *sendtype,
	MPI_Fint *dest, MPI_Fint *sendtag, void *recvbuf, MPI_Fint *recvcount,
	MPI_Fint *recvtype, MPI_Fint *source, MPI_Fint *recvtag, 
	MPI_Fint *comm, MPI_Fint *status, MPI_Fint *__ierr) {
 MPI_Status c_status;

 *__ierr = MPI_Sendrecv(sendbuf, *sendcount, MPI_Type_f2c(*sendtype), *dest, 
		*sendtag, recvbuf, *recvcount, MPI_Type_f2c(*recvtype),
		*source, *recvtag, MPI_Comm_f2c(*comm), &c_status);
  if (*__ierr == MPI_SUCCESS) MPI_Status_c2f(&c_status, status);
}

void FSUB(MPI_Sendrecv_replace)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *sendtag, MPI_Fint *source, MPI_Fint *recvtag,
	MPI_Fint *comm, MPI_Fint *status, MPI_Fint *__ierr) {
  MPI_Status c_status;

  *__ierr = MPI_Sendrecv_replace(buf, *count, MPI_Type_f2c(*datatype), *dest, 
		*sendtag, *source, *recvtag, MPI_Comm_f2c(*comm), &c_status);
  if (*__ierr == MPI_SUCCESS) MPI_Status_c2f(&c_status, status);
}

void FSUB(MPI_Isend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Isend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Irecv)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *source, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Irecv(buf, *count, MPI_Type_f2c(*datatype), *source, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Ibsend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Ibsend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Irsend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Irsend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Issend)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Issend(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Wait)(MPI_Fint *request, MPI_Fint *status, MPI_Fint *__ierr) {
  MPI_Request lrequest;
  MPI_Status c_status;

  lrequest = MPI_Request_f2c(*request);
  *__ierr = MPI_Wait(&lrequest, &c_status);
  *request = MPI_Request_c2f(lrequest);
  if (*__ierr == MPI_SUCCESS) MPI_Status_c2f(&c_status, status);
}

void FSUB(MPI_Waitall)(MPI_Fint *count, MPI_Fint array_of_requests[],
	MPI_Fint array_of_statuses[][ELG_MPI_STATUS_SIZE], MPI_Fint *__ierr ) {
  int i;
  MPI_Request *lrequest = 0;
  MPI_Status *c_status = 0;

  if (*count > 0) {
    lrequest = alloc_request_array(*count);
    c_status = alloc_status_array(*count);
    for (i=0; i<*count; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Waitall(*count, lrequest, c_status);
  for (i=0; i<*count; i++) {
    array_of_requests[i] = MPI_Request_c2f(lrequest[i]);
  }
  if (*__ierr == MPI_SUCCESS) {
    for (i=0; i<*count; i++) {
      MPI_Status_c2f(&(c_status[i]), &(array_of_statuses[i][0]));
    }
  }
}

void FSUB(MPI_Waitany)(MPI_Fint *count, MPI_Fint array_of_requests[],
	MPI_Fint *index, MPI_Fint *status, MPI_Fint *__ierr) {
  int i;
  MPI_Request *lrequest = 0;
  MPI_Status c_status;

  if (*count > 0) {
    lrequest = alloc_request_array(*count);
    for (i=0; i<*count; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Waitany(*count, lrequest, index, &c_status);
  if (*__ierr == MPI_SUCCESS) {
    if (*index >= 0) {
      /* index may be MPI_UNDEFINED if all are null */
      array_of_requests[*index] = MPI_Request_c2f(lrequest[*index]);
    
      /* See the description of waitany in the standard;
         the Fortran index ranges are from 1, not zero */
      (*index)++;
    }
    MPI_Status_c2f(&c_status, status);
  }
}

void FSUB(MPI_Waitsome)(MPI_Fint *incount, MPI_Fint array_of_requests[],
	MPI_Fint *outcount, MPI_Fint indices[],
	MPI_Fint array_of_statuses[][ELG_MPI_STATUS_SIZE], MPI_Fint *__ierr) {
  int i, j, found;
  MPI_Request *lrequest = 0;
  MPI_Status  *c_status = 0;

  if (*incount > 0) {
    lrequest = alloc_request_array(*incount);
    c_status = alloc_status_array(*incount);
    for (i=0; i<*incount; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Waitsome(*incount, lrequest, outcount, indices, c_status); 
  if (*__ierr == MPI_SUCCESS) {
    for (i=0; i<*incount; i++) {
      if (i < *outcount) {
        if (indices[i] >= 0) {
          array_of_requests[indices[i]] = MPI_Request_c2f(lrequest[indices[i]]);
        }
      } else {
        found = j = 0;
        while ( (!found) && (j<*outcount) ) {
          if (indices[j++] == i) found = 1;
        }
	if (!found) array_of_requests[i] = MPI_Request_c2f(lrequest[i]);
      }
    }
    for (i=0; i<*outcount; i++) {
      MPI_Status_c2f(&c_status[i], &(array_of_statuses[i][0]));
      /* See the description of waitsome in the standard;
         the Fortran index ranges are from 1, not zero */
      if (indices[i] >= 0) indices[i]++;
    }
  }
}

void FSUB(MPI_Test)(MPI_Fint *request, MPI_Fint *flag, MPI_Fint *status,
	MPI_Fint *__ierr) {
  MPI_Status c_status;
  MPI_Request lrequest = MPI_Request_f2c(*request);

  *__ierr = MPI_Test(&lrequest, flag, &c_status);
  if (*__ierr != MPI_SUCCESS) return;
  *request = MPI_Request_c2f(lrequest);
  if (flag) MPI_Status_c2f(&c_status, status);
}

void FSUB(MPI_Testany)(MPI_Fint* count, MPI_Fint array_of_requests[],
	MPI_Fint* index, MPI_Fint* flag, MPI_Fint *status, MPI_Fint* __ierr) {
  int i;
  MPI_Request *lrequest = 0;
  MPI_Status c_status;

  if (*count > 0) {
    lrequest = alloc_request_array(*count);
    for (i=0; i<*count; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Testany(*count, lrequest, index, flag, &c_status);
  if (*__ierr == MPI_SUCCESS) {
    if (*flag && *index >= 0) {
      /* index may be MPI_UNDEFINED if all are null */
      array_of_requests[*index] = MPI_Request_c2f(lrequest[*index]);
    
      /* See the description of waitany in the standard;
         the Fortran index ranges are from 1, not zero */
      (*index)++;
    }
    MPI_Status_c2f(&c_status, status);
  }
}

void FSUB(MPI_Testall)(MPI_Fint *count, MPI_Fint array_of_requests[],
	MPI_Fint *flag, MPI_Fint array_of_statuses[][ELG_MPI_STATUS_SIZE],
	MPI_Fint *__ierr ) {
  int i;
  MPI_Request *lrequest = 0;
  MPI_Status *c_status = 0;

  if (*count > 0) {
    lrequest = alloc_request_array(*count);
    c_status = alloc_status_array(*count);
    for (i=0; i<*count; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Testall(*count, lrequest, flag, c_status);
  for (i=0; i<*count; i++) {
    array_of_requests[i] = MPI_Request_c2f(lrequest[i]);
  }
  if (*__ierr == MPI_SUCCESS && *flag) {
    for (i=0; i<*count; i++) {
      MPI_Status_c2f(&(c_status[i]), &(array_of_statuses[i][0]));
    }
  }
}

void FSUB(MPI_Testsome)(MPI_Fint *incount, MPI_Fint array_of_requests[],
	MPI_Fint *outcount, MPI_Fint indices[],
	MPI_Fint array_of_statuses[][ELG_MPI_STATUS_SIZE], MPI_Fint *__ierr) {
  int i, j, found;
  MPI_Request *lrequest = 0;
  MPI_Status  *c_status = 0;

  if (*incount > 0) {
    lrequest = alloc_request_array(*incount);
    c_status = alloc_status_array(*incount);
    for (i=0; i<*incount; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Testsome(*incount, lrequest, outcount, indices, c_status); 
  if (*__ierr == MPI_SUCCESS) {
    for (i=0; i<*incount; i++) {
      if (i < *outcount) {
        array_of_requests[indices[i]] = MPI_Request_c2f(lrequest[indices[i]]);
      } else {
        found = j = 0;
        while ( (!found) && (j<*outcount) ) {
          if (indices[j++] == i) found = 1;
        }
	if (!found) array_of_requests[i] = MPI_Request_c2f(lrequest[i]);
      }
    }
    for (i=0; i<*outcount; i++) {
      MPI_Status_c2f(&c_status[i], &(array_of_statuses[i][0]));
      /* See the description of testsome in the standard;
         the Fortran index ranges are from 1, not zero */
      if (indices[i] >= 0) indices[i]++;
    }
  }
}

void FSUB(MPI_Send_init)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Send_init(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Bsend_init)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Bsend_init(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Rsend_init)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Rsend_init(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Ssend_init)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *dest, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Ssend_init(buf, *count, MPI_Type_f2c(*datatype), *dest, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Recv_init)(void *buf, MPI_Fint *count, MPI_Fint *datatype,
	MPI_Fint *source, MPI_Fint *tag, MPI_Fint *comm, MPI_Fint *request,
	MPI_Fint *__ierr) {
  MPI_Request lrequest;

  *__ierr = MPI_Recv_init(buf, *count, MPI_Type_f2c(*datatype), *source, *tag,
		MPI_Comm_f2c(*comm), &lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Start)(MPI_Fint *request, MPI_Fint *__ierr) {
  MPI_Request lrequest = MPI_Request_f2c(*request);

  *__ierr = MPI_Start(&lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Startall)(MPI_Fint* count, MPI_Fint array_of_requests[],
	MPI_Fint* __ierr) {
  int i;
  MPI_Request *lrequest = 0;

  if (*count > 0) {
    lrequest = alloc_request_array(*count);
    for (i=0; i<*count; i++) {
      lrequest[i] = MPI_Request_f2c(array_of_requests[i]);
    }
  }
  *__ierr = MPI_Startall(*count, lrequest);
  if (*__ierr == MPI_SUCCESS) {
    for (i=0; i<*count; i++) {
      array_of_requests[i] = MPI_Request_c2f(lrequest[i]);
    }
  }
}

void FSUB(MPI_Request_free)(MPI_Fint *request, MPI_Fint *__ierr) {
  MPI_Request lrequest = MPI_Request_f2c(*request);

  *__ierr = MPI_Request_free(&lrequest);
  if (*__ierr == MPI_SUCCESS) *request = MPI_Request_c2f(lrequest);
}

void FSUB(MPI_Cancel)(MPI_Fint *request, MPI_Fint *__ierr) {
  MPI_Request lrequest;

  lrequest = MPI_Request_f2c(*request);  
  *__ierr = MPI_Cancel(&lrequest); 
}

void FSUB(MPI_Allreduce)(void *sendbuf, void *recvbuf, MPI_Fint *count,
	MPI_Fint *datatype, MPI_Fint *op, MPI_Fint *comm, MPI_Fint *__ierr) {
  *__ierr = MPI_Allreduce(sendbuf, recvbuf, *count, MPI_Type_f2c(*datatype),
		MPI_Op_f2c(*op), MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Barrier)(MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Barrier(MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Bcast)(void* buf, MPI_Fint* count, MPI_Fint* datatype,
	MPI_Fint* root, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Bcast(buf, *count, MPI_Type_f2c(*datatype), *root,
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Gather)(void* sendbuf, MPI_Fint* sendcount, MPI_Fint* sendtype,
	void* recvbuf, MPI_Fint* recvcount, MPI_Fint* recvtype,
	MPI_Fint* root, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Gather(sendbuf, *sendcount, MPI_Type_f2c(*sendtype), recvbuf,
		*recvcount, MPI_Type_f2c(*recvtype), *root,
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Reduce)(void* sendbuf, void* recvbuf, MPI_Fint* count, 
	MPI_Fint* datatype, MPI_Fint* op, MPI_Fint* root, MPI_Fint* comm,
	MPI_Fint* __ierr) {
  *__ierr = MPI_Reduce(sendbuf, recvbuf, *count, MPI_Type_f2c(*datatype),
		MPI_Op_f2c(*op), *root, MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Gatherv)(void* sendbuf, MPI_Fint* sendcount, MPI_Fint* sendtype,
	void* recvbuf, MPI_Fint* recvcounts, MPI_Fint* displs,
	MPI_Fint* recvtype, MPI_Fint* root, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Gatherv(sendbuf, *sendcount, MPI_Type_f2c(*sendtype),
		recvbuf, recvcounts, displs, MPI_Type_f2c(*recvtype),
		*root, MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Allgather)(void* sendbuf, MPI_Fint* sendcount, MPI_Fint* sendtype,
	void* recvbuf, MPI_Fint* recvcount, MPI_Fint* recvtype, MPI_Fint* comm,
	MPI_Fint* __ierr) {
  *__ierr = MPI_Allgather(sendbuf, *sendcount, MPI_Type_f2c(*sendtype),
		recvbuf, *recvcount, MPI_Type_f2c(*recvtype),
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Allgatherv)(void* sendbuf, MPI_Fint* sendcount,
	MPI_Fint* sendtype, void* recvbuf, MPI_Fint* recvcounts,
	MPI_Fint* displs, MPI_Fint* recvtype, MPI_Fint* comm,
	MPI_Fint* __ierr) {
  *__ierr = MPI_Allgatherv(sendbuf, *sendcount, MPI_Type_f2c(*sendtype),
		recvbuf, recvcounts, displs, MPI_Type_f2c(*recvtype),
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Alltoall)(void* sendbuf, MPI_Fint* sendcount, MPI_Fint* sendtype,
	void* recvbuf, MPI_Fint* recvcnt, MPI_Fint* recvtype, MPI_Fint* comm,
	MPI_Fint* __ierr) {
  *__ierr = MPI_Alltoall(sendbuf, *sendcount, MPI_Type_f2c(*sendtype), recvbuf,
		*recvcnt, MPI_Type_f2c(*recvtype), MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Alltoallv)(void* sendbuf, MPI_Fint* sendcnts, MPI_Fint* sdispls,
	MPI_Fint* sendtype, void* recvbuf, MPI_Fint* recvcnts,
	MPI_Fint* rdispls, MPI_Fint* recvtype, MPI_Fint* comm,
	MPI_Fint* __ierr) {
  *__ierr = MPI_Alltoallv(sendbuf, sendcnts, sdispls, MPI_Type_f2c(*sendtype),
		recvbuf, recvcnts, rdispls, MPI_Type_f2c(*recvtype),
		MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Scan)(void* sendbuf, void* recvbuf, MPI_Fint* count,
	MPI_Fint* datatype, MPI_Fint* op, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Scan(sendbuf, recvbuf, *count, MPI_Type_f2c(*datatype),
		MPI_Op_f2c(*op), MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Scatter)(void* sendbuf, MPI_Fint* sendcnt, MPI_Fint* sendtype,
	void* recvbuf, MPI_Fint* recvcnt, MPI_Fint* recvtype, MPI_Fint* root,
	MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Scatter(sendbuf, *sendcnt, MPI_Type_f2c(*sendtype),
		recvbuf, *recvcnt, MPI_Type_f2c(*recvtype),
		*root, MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Scatterv)(void* sendbuf, MPI_Fint* sendcnts, MPI_Fint* displs,
	MPI_Fint* sendtype, void* recvbuf, MPI_Fint* recvcnt,
	MPI_Fint* recvtype, MPI_Fint* root, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Scatterv(sendbuf, sendcnts, displs, MPI_Type_f2c(*sendtype),
		recvbuf, *recvcnt, MPI_Type_f2c(*recvtype),
		*root, MPI_Comm_f2c(*comm));
}

void FSUB(MPI_Reduce_scatter)(void* sendbuf, void* recvbuf, MPI_Fint* recvcnts,
	MPI_Fint* datatype, MPI_Fint* op, MPI_Fint* comm, MPI_Fint* __ierr) {
  *__ierr = MPI_Reduce_scatter(sendbuf, recvbuf, recvcnts,
		MPI_Type_f2c(*datatype), MPI_Op_f2c(*op), MPI_Comm_f2c(*comm));
}

#endif /* !NEED_F2C_CONV */
