/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_IMPL_H
#define _ELG_IMPL_H

/*
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Basic definitions for elg_gen and elg_rw
 *
 *-----------------------------------------------------------------------------
 */

#define ELG_MIN_BUFSIZE 100000  

#define ELG_HEADER      "EPILOG"

#define ELG_MAJOR_VNR   1
#define ELG_MINOR_VNR   1

typedef unsigned char* buffer_t;

#endif
