/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_ENV_H
#define _ELG_ENV_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

#include <stdio.h>

/*
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Accessing the EPILOG environment variables
 * 
 *-----------------------------------------------------------------------------
 */

EXTERN char*  elg_env_gdir();
EXTERN char*  elg_env_ldir();
EXTERN char*  elg_env_fprefix();
EXTERN size_t elg_env_bsize();
EXTERN int    elg_env_is_verbose();
EXTERN int    elg_env_do_merge();
EXTERN char*  elg_env_metrics();

#endif



















